#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

typedef struct{
    char name[30];
    int age;
    enum{male,female} sex;
}student;

int addData(FILE* f);
void list(FILE *f);
void listStudents(student* studs,int count);
int readStudent(student* stud);
student* findByName(FILE *f, char *name);
char *readName(int size);

int main(void)
{
    FILE *f = fopen("studenti.dat","r+b");
    if(!f)f=fopen("studenti.dat","w+b");
    addData(f);
    char* stud = readName(30);
    student * value = findByName(f,stud);
    if(value)listStudents(value,1);
    else printf("Dany student nenalezen!\n");
    list(f);
    fclose(f);
    return 0;
}

int addData(FILE* f)
{
    student stud;
    int count = 0 ;
    while(readStudent(&stud))
    {
        fwrite(&stud,sizeof(student),1,f);
        count++;
    }
    fflush(f);
    return count;
}
int readStudent(student* stud)
{
    char sex;
    printf("Jmeno studenta:");
    fgets(stud->name,10,stdin);
    if(strchr(stud->name,'\n')!=NULL)*strchr(stud->name,'\n')=0;
    else while(getchar()!='\n');
    if(!strlen(stud->name))return 0;
    printf("Vek:");
    scanf("%d",&stud->age);
    printf("Pohlavi (m/z):");
    sex = getchar();
    while(getchar()!='\n');
    if(sex=='m')stud->sex=male;
    else stud->sex=female;
    return 1;


}
char* readName(int size)
{
    char * name =(char*)calloc(size,sizeof(char));
    fgets(name,size,stdin);
    if(strchr(name,'\n')!=NULL)*strchr(name,'\n')=0;
    else while(getchar()!='\n');
    return name;
}

void list(FILE *f)
{
    student val;
    fseek(f,0,SEEK_SET);
    while(!feof(f))
    {
        fread(&val,sizeof(student),1,f);
        printf("%s %d %s\n",val.name,val.age,(val.sex==male?"male":"female"));
    }
}

void listStudents(student* studs,int count)
{
    for(int i=0;i<count;i++)
    {
        printf("%s %d %s\n",studs[i].name,studs[i].age,(studs[i].sex==male?"male":"female"));
    }
}

student* findByName(FILE *f,char * name)
{
    student* rv=(student*)malloc(sizeof(student));
    while(!feof(f))
    {
        fread(rv,sizeof(student),1,f);
        if(strcasecmp(name,rv->name)==0)return rv;
    }
    return NULL;
}

